diff --git a/src/main/java/net/minecraft/core/player/inventory/Container.java b/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
similarity index 71%
rename from src/main/java/net/minecraft/core/player/inventory/Container.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
index c8a1b5766..dcc408947 100644
--- a/src/main/java/net/minecraft/core/player/inventory/Container.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/AbstractContainerMenu.java
@@ -1,85 +1,86 @@
-package net.minecraft.core.player.inventory;
+package net.minecraft.core.player.inventory.menu;
 
 import java.util.*;
 
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.Global;
-import net.minecraft.core.crafting.ICrafting;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.crafting.ContainerListener;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.IArmorItem;
 import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemArmor;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.container.Inventory;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotCrafting;
-import net.minecraft.core.util.helper.Listener;
+import net.minecraft.core.player.inventory.slot.ResultSlot;
 import net.minecraft.core.util.helper.MathHelper;
 
-public abstract class Container
+public abstract class AbstractContainerMenu
 {
 
-	public List<ItemStack> inventoryItemStacks;
-	public List<Slot> inventorySlots;
-	public int windowId;
-	private short lastActionId;
-	protected List<ICrafting> crafters;
-	private final Set<EntityPlayer> field_20918_b;
-	public Listener<Slot> slotUpdateListener;
+	public List<ItemStack> lastSlots;
+	public List<Slot> slots;
+	public int containerId;
+	private short changeUid;
+	protected List<ContainerListener> containerListeners;
+	private final Set<Player> unSynchedPlayers;
 
-	public Container()
+	public AbstractContainerMenu()
 	{
-		inventoryItemStacks = new ArrayList<>();
-		inventorySlots = new ArrayList<>();
-		windowId = 0;
-		lastActionId = 0;
-		crafters = new ArrayList<>();
-		field_20918_b = new HashSet<>();
+		lastSlots = new ArrayList<>();
+		slots = new ArrayList<>();
+		containerId = 0;
+		changeUid = 0;
+		containerListeners = new ArrayList<>();
+		unSynchedPlayers = new HashSet<>();
 	}
 
 	protected void addSlot(Slot slot)
 	{
-		slot.id = inventorySlots.size();
-		inventorySlots.add(slot);
-		inventoryItemStacks.add(null);
+		slot.index = slots.size();
+		slots.add(slot);
+		lastSlots.add(null);
 	}
 
-	public void onContainerInit(ICrafting icrafting)
+	public void addSlotListener(ContainerListener containerListener)
 	{
-		if(crafters.contains(icrafting))
+		if(containerListeners.contains(containerListener))
 		{
 			throw new IllegalArgumentException("Listener already listening");
-		} else
+		}
+		else
 		{
-			crafters.add(icrafting);
-			icrafting.updateCraftingInventory(this, func_28127_b());
-			updateInventory();
+			containerListeners.add(containerListener);
+			containerListener.updateCraftingInventory(this, func_28127_b());
+			broadcastChanges();
 		}
 	}
 
 	public List<ItemStack> func_28127_b()
 	{
 		List<ItemStack> arraylist = new ArrayList<>();
-		for (Slot inventorySlot : inventorySlots) {
-			arraylist.add(inventorySlot.getStack());
+		for (Slot inventorySlot : slots) {
+			arraylist.add(inventorySlot.getItem());
 		}
 
 		return arraylist;
 	}
 
 
-	public void updateInventory()
+	public void broadcastChanges()
 	{
-		for(int i = 0; i < inventorySlots.size(); i++)
+		for(int i = 0; i < slots.size(); i++)
 		{
 
-			ItemStack itemstack = ((Slot)inventorySlots.get(i)).getStack();
-			ItemStack itemstack1 = (ItemStack)inventoryItemStacks.get(i);
+			ItemStack itemstack = ((Slot) slots.get(i)).getItem();
+			ItemStack itemstack1 = (ItemStack) lastSlots.get(i);
 			if(ItemStack.areItemStacksEqual(itemstack1, itemstack))
 			{
 				continue;
 			}
 			itemstack1 = itemstack != null ? itemstack.copy() : null;
-			inventoryItemStacks.set(i, itemstack1);
-			for (ICrafting crafter : crafters) {
+			lastSlots.set(i, itemstack1);
+			for (ContainerListener crafter : containerListeners) {
 				crafter.updateInventorySlot(this, i, itemstack1);
 			}
 
@@ -87,12 +88,11 @@ public abstract class Container
 
 	}
 
-	public Slot func_20127_a(IInventory iinventory, int i)
+	public Slot getSlotFor(Container container, int i)
 	{
-		for (Slot inventorySlot : inventorySlots) {
-			Slot slot = inventorySlot;
-			if (slot.isHere(iinventory, i)) {
-				return slot;
+		for (Slot inventorySlot : slots) {
+            if (inventorySlot.isAt(container, i)) {
+				return inventorySlot;
 			}
 		}
 
@@ -103,7 +103,7 @@ public abstract class Container
 	public Slot getSlot(int i)
 	{
 		try{
-			return (Slot) inventorySlots.get(i);
+			return (Slot) slots.get(i);
 		}catch (Exception e) {
 			return null;
 		}
@@ -114,7 +114,7 @@ public abstract class Container
 	 * The returned ItemStack is used to check if the client has the same items as the server.
 	 * If they are different, the server sends the inventory again.
 	 */
-	public ItemStack clickInventorySlot(InventoryAction action, int[] args, EntityPlayer player) {
+	public ItemStack clicked(InventoryAction action, int[] args, Player player) {
 		if(action.requireCreative()) {
 			if(player.getGamemode().consumeBlocks()) {
 				System.out.println("Player "+player.username+" used a creative inventory action but is not in creative mode!");
@@ -122,7 +122,7 @@ public abstract class Container
 			}
 		}
 		
-		InventoryPlayer inventory = player.inventory;
+		Inventory inventory = player.inventory;
 
 		//Drop Item
 		if(action == InventoryAction.DROP_HELD_SINGLE || action == InventoryAction.DROP_HELD_STACK) {
@@ -138,7 +138,7 @@ public abstract class Container
 					}
 				}
 			}
-			onCraftMatrixChanged(inventory);
+			slotsChanged(inventory);
 			return null;
 		}
 
@@ -153,7 +153,7 @@ public abstract class Container
 			}else {
 				dragItemsAcrossSlots(player, action, args);
 			}
-			onCraftMatrixChanged(player.inventory);
+			slotsChanged(player.inventory);
 			return controlStack;
 		}
 
@@ -163,13 +163,13 @@ public abstract class Container
 		int slotId = args[0];
 		Slot slot = getSlot(slotId);
 		if(slot == null) {
-			onCraftMatrixChanged(inventory);
+			slotsChanged(inventory);
 			return null;
 		}
 
 		//Used in multiplayer to check if the item the player clicked is the same item on the server
 		ItemStack controlStack = null;
-		ItemStack stackInSlot = slot.getStack();
+		ItemStack stackInSlot = slot.getItem();
 		Item itemInSlot = stackInSlot != null ? stackInSlot.getItem() : null;
 		
 		if(stackInSlot != null) {
@@ -198,33 +198,33 @@ public abstract class Container
 			if(result != null && result.stackSize <= 0) {
 				result = null;
 			}
-			slot.putStack(result);
+			slot.set(result);
 			
 			grabbedItem = player.inventory.getHeldItemStack();
 			if(grabbedItem != null && grabbedItem.stackSize <= 0) {
 				player.inventory.setHeldItemStack(null);
 			}
 			
-			onCraftMatrixChanged(inventory);
+			slotsChanged(inventory);
 			return controlStack;
 		}
 		
 		if(action == InventoryAction.EQUIP_ARMOR) {
 			handleArmorEquip(slot, player);
-			onCraftMatrixChanged(inventory);
+			slotsChanged(inventory);
 			return controlStack;
 		}
 		
 		if(action == InventoryAction.HOTBAR_ITEM_SWAP) {
 			handleHotbarSwap(args, player);
-			onCraftMatrixChanged(inventory);
+			slotsChanged(inventory);
 			return controlStack;
 		}
 
 		if(action == InventoryAction.MOVE_STACK || action == InventoryAction.MOVE_SINGLE_ITEM || action == InventoryAction.MOVE_SIMILAR || action == InventoryAction.MOVE_ALL) {
 			int target = args.length > 1 ? args[1] : 0;
 			handleItemMove(action, slot, target, player);
-			onCraftMatrixChanged(player.inventory);
+			slotsChanged(player.inventory);
 			return controlStack;
 		}
 
@@ -233,12 +233,12 @@ public abstract class Container
 				return null;
 			}
 			handleSort(args, player);
-			onCraftMatrixChanged(inventory);
+			slotsChanged(inventory);
 			return controlStack;
 		}
 
 		//Regular Press
-		slot.onSlotChanged();
+		slot.setChanged();
 		ItemStack stackInHand = inventory.getHeldItemStack();
 
 		if(action == InventoryAction.DROP) {
@@ -247,13 +247,13 @@ public abstract class Container
 			}
 			int amount = args.length > 1 ? args[1] : 1;
 			amount = Math.min(amount, stackInSlot.stackSize);
-			ItemStack dropStack = slot.decrStackSize(amount);
+			ItemStack dropStack = slot.remove(amount);
 			if(stackInSlot.stackSize <= 0) {
-				slot.putStack(null);
+				slot.set(null);
 			}
-			slot.onPickupFromSlot(dropStack);
+			slot.onTake(dropStack);
 			player.dropPlayerItem(dropStack);
-			onCraftMatrixChanged(inventory);
+			slotsChanged(inventory);
 			return controlStack;
 		}
 
@@ -265,7 +265,7 @@ public abstract class Container
 				for(int i=0; i < count; i++) {
 					Slot slot1 = getSlot(slotId + i);
 					if(slot1 != null) {
-						slot1.putStack(null);
+						slot1.set(null);
 					}
 				}
 			}else {
@@ -278,7 +278,7 @@ public abstract class Container
 				if(action == InventoryAction.CREATIVE_GRAB) {
 					ItemStack stack;
 					if(amount > 0) {
-						stack = slot.getStack().copy();
+						stack = slot.getItem().copy();
 						stack.stackSize = amount;
 					}else {
 						stack = null;
@@ -287,25 +287,25 @@ public abstract class Container
 				}
 				if(action == InventoryAction.CREATIVE_MOVE) {
 					if(amount > 0) {
-						ItemStack stack = slot.getStack().copy();
+						ItemStack stack = slot.getItem().copy();
 						stack.stackSize = amount;
 						player.inventory.insertItem(stack, false);
 					}
 				}
 			}
-			onCraftMatrixChanged(player.inventory);
+			slotsChanged(player.inventory);
 			return controlStack;
 		}
 
 		//Clicked Empty Slot
 		if(stackInSlot == null) {
 			//Slot is Empty
-			if(stackInHand != null && slot.canPutStackInSlot(stackInHand)) {
+			if(stackInHand != null && slot.mayPlace(stackInHand)) {
 				int i1 = action != InventoryAction.CLICK_LEFT ? 1 : stackInHand.stackSize;
-				if(i1 > slot.getSlotStackLimit()) {
-					i1 = slot.getSlotStackLimit();
+				if(i1 > slot.getMaxStackSize()) {
+					i1 = slot.getMaxStackSize();
 				}
-				slot.putStack(stackInHand.splitStack(i1));
+				slot.set(stackInHand.splitStack(i1));
 				if(stackInHand.stackSize <= 0) {
 					inventory.setHeldItemStack(null);
 				}
@@ -313,25 +313,25 @@ public abstract class Container
 		} else if(stackInHand == null) {
 			//Not Holding Anything
 			int j1 = action != InventoryAction.CLICK_LEFT ? (stackInSlot.stackSize + 1) / 2 : stackInSlot.stackSize;
-			ItemStack itemstack5 = slot.decrStackSize(j1);
+			ItemStack itemstack5 = slot.remove(j1);
 			inventory.setHeldItemStack(itemstack5);
 			if(stackInSlot.stackSize <= 0) {
-				slot.putStack(null);
+				slot.set(null);
 			}
-			slot.onPickupFromSlot(inventory.getHeldItemStack());
-		} else if(slot.canPutStackInSlot(stackInHand)) {
+			slot.onTake(inventory.getHeldItemStack());
+		} else if(slot.mayPlace(stackInHand)) {
 			//Can Put Stack in Slot
 			if(!stackInSlot.canStackWith(stackInHand)) {
 				//Swap Items
-				if(stackInHand.stackSize <= slot.getSlotStackLimit()) {
-					slot.putStack(stackInHand);
+				if(stackInHand.stackSize <= slot.getMaxStackSize()) {
+					slot.set(stackInHand);
 					inventory.setHeldItemStack(stackInSlot);
 				}
 			} else {
 				//Combine Stacks
 				int splitSize = action != InventoryAction.CLICK_LEFT ? 1 : stackInHand.stackSize;
-				if(splitSize > slot.getSlotStackLimit() - stackInSlot.stackSize) {
-					splitSize = slot.getSlotStackLimit() - stackInSlot.stackSize;
+				if(splitSize > slot.getMaxStackSize() - stackInSlot.stackSize) {
+					splitSize = slot.getMaxStackSize() - stackInSlot.stackSize;
 				}
 				if(splitSize > stackInHand.getMaxStackSize() - stackInSlot.stackSize) {
 					splitSize = stackInHand.getMaxStackSize() - stackInSlot.stackSize;
@@ -345,11 +345,11 @@ public abstract class Container
 		} else if(stackInSlot.canStackWith(stackInHand)) {
 			//Pickup Item
 			if(stackInSlot.stackSize + stackInHand.stackSize <= stackInHand.getMaxStackSize()) {
-				slot.putStack(null);
+				slot.set(null);
 
 				//This is currently used for maps, and for Crafting Statistics / Achievements
 				//This might modify the stack
-				slot.onPickupFromSlot(stackInSlot);
+				slot.onTake(stackInSlot);
 
 				if(stackInSlot.canStackWith(stackInHand) && stackInHand.stackSize + stackInSlot.stackSize <= stackInHand.getMaxStackSize()) {
 					stackInHand.stackSize += stackInSlot.stackSize;
@@ -364,48 +364,48 @@ public abstract class Container
 			inventory.setHeldItemStack(null);
 		}
 
-		onCraftMatrixChanged(player.inventory);
+		slotsChanged(player.inventory);
 
 		return controlStack;
 	}
 	
-	public void handleArmorEquip(Slot slot, EntityPlayer player) {
-		ItemStack stackInSlot = slot.getStack();
+	public void handleArmorEquip(Slot slot, Player player) {
+		ItemStack stackInSlot = slot.getItem();
 		if(stackInSlot == null) {
 			return;
 		}
 		
 		Item itemInSlot = stackInSlot.getItem();
-		ItemArmor itemArmor;
+		IArmorItem armorItem;
 		
 		// Check if item is armor
-		if(itemInSlot instanceof ItemArmor) {
-			itemArmor = (ItemArmor) itemInSlot;
+		if(itemInSlot instanceof IArmorItem) {
+			armorItem = (IArmorItem) itemInSlot;
 		}else {
 			return;
 		}
 		
-		int armorSlot = 3 - itemArmor.armorPiece;
+		int armorSlot = 3 - armorItem.getArmorPiece();
 		
 		// Take new armor
 		ItemStack newArmor = stackInSlot;
-		slot.putStack(null);
-		slot.onPickupFromSlot(stackInSlot);
-		slot.onSlotChanged();
+		slot.set(null);
+		slot.onTake(stackInSlot);
+		slot.setChanged();
 		
 		// Equip new armor
 		ItemStack oldArmor = player.inventory.armorInventory[armorSlot];
 		player.inventory.armorInventory[armorSlot] = newArmor;
 		
 		// Put old armor in slot, or drop if not possible
-		mergeItems(oldArmor, slot.id);
+		mergeItems(oldArmor, slot.index);
 		storeOrDropItem(player, oldArmor);
 	}
 
 	/*
 	 * Handle the SORT action
 	 */
-	public void handleSort(int[] args, EntityPlayer player) {
+	public void handleSort(int[] args, Player player) {
 		if (args.length < 1) {
 			return;
 		}
@@ -420,7 +420,7 @@ public abstract class Container
 	/**
 	 * Handle the HOTBAR_ITEM_SWAP action
 	 */
-	public void handleHotbarSwap(int[] args, EntityPlayer player) {
+	public void handleHotbarSwap(int[] args, Player player) {
 		if(args.length < 2) {
 			return;
 		}
@@ -436,36 +436,36 @@ public abstract class Container
 			return;
 		}
 
-		ItemStack slotStack = slot.getStack();
-		ItemStack hotbarStack = hotbarSlot.getStack();
+		ItemStack slotStack = slot.getItem();
+		ItemStack hotbarStack = hotbarSlot.getItem();
 
 		if(slotStack != null) {
-			slot.putStack(null);
-			slot.onPickupFromSlot(slotStack);
+			slot.set(null);
+			slot.onTake(slotStack);
 		}
 		if(hotbarStack != null) {
-			hotbarSlot.putStack(null);
-			hotbarSlot.onPickupFromSlot(hotbarStack);
+			hotbarSlot.set(null);
+			hotbarSlot.onTake(hotbarStack);
 		}
 
-		mergeItems(slotStack, hotbarSlot.id);
+		mergeItems(slotStack, hotbarSlot.index);
 		storeOrDropItem(player, slotStack);
 
-		mergeItems(hotbarStack, slot.id);
+		mergeItems(hotbarStack, slot.index);
 		storeOrDropItem(player, hotbarStack);
 
-		slot.onSlotChanged();
-		hotbarSlot.onSlotChanged();
+		slot.setChanged();
+		hotbarSlot.setChanged();
 	}
 
 	/**
 	 * Handles all MOVE actions
 	 */
-	public void handleItemMove(InventoryAction action, Slot slot, int target, EntityPlayer player) {
-		ItemStack stackInSlot = slot.getStack();
+	public void handleItemMove(InventoryAction action, Slot slot, int target, Player player) {
+		ItemStack stackInSlot = slot.getItem();
 
-		if(slot instanceof SlotCrafting) {
-			handleCrafting(action, (SlotCrafting) slot, target, player);
+		if(slot instanceof ResultSlot) {
+			handleCrafting(action, (ResultSlot) slot, target, player);
 			return;
 		}
 
@@ -482,7 +482,7 @@ public abstract class Container
 			if(action == InventoryAction.MOVE_STACK) item = stackInSlot.splitStack(stackInSlot.stackSize);
 			if(item == null) return;
 			
-			slot.onPickupFromSlot(item);
+			slot.onTake(item);
 			
 			mergeItems(item, targetSlots);
 
@@ -492,7 +492,7 @@ public abstract class Container
 			}
 
 			if(stackInSlot.stackSize <= 0) {
-				slot.putStack(null);
+				slot.set(null);
 			}
 
 			return;
@@ -515,17 +515,17 @@ public abstract class Container
 				if(slot1 == null) {
 					continue;
 				}
-				ItemStack item = slot1.getStack();
+				ItemStack item = slot1.getItem();
 				if(compare(compareStack, item)) {
 					int freeSpace = getFreeSpace(item, targetSlots);
 					if(freeSpace > 0) {
 						int amount = Math.min(freeSpace, item.stackSize);
 						ItemStack takenItem = item.splitStack(amount);
-						slot.onPickupFromSlot(takenItem);
+						slot.onTake(takenItem);
 						
 						mergeItems(takenItem, targetSlots);
 						if(item.stackSize <= 0) {
-							slot1.putStack(null);
+							slot1.set(null);
 						}
 						if(takenItem.stackSize > 0) {
 							player.dropPlayerItem(takenItem);
@@ -548,8 +548,8 @@ public abstract class Container
 	/**
 	 * Handle MOVE actions on crafting result slots
 	 */
-	public void handleCrafting(InventoryAction action, SlotCrafting slot, int target, EntityPlayer player) {
-		ItemStack itemToCraft = slot.getStack();
+	public void handleCrafting(InventoryAction action, ResultSlot slot, int target, Player player) {
+		ItemStack itemToCraft = slot.getItem();
 
 		if(itemToCraft == null) {
 			return;
@@ -573,7 +573,7 @@ public abstract class Container
 		}
 
 		for(int i=0; i < craftCount; i++) {
-			itemToCraft = slot.getStack();
+			itemToCraft = slot.getItem();
 
 			if(itemToCraft == null) {
 				break;
@@ -586,9 +586,9 @@ public abstract class Container
 			int space = getFreeSpace(itemToCraft, resultSlots);
 
 			if(space >= itemToCraft.stackSize) {
-				slot.putStack(null);
-				slot.onPickupFromSlot(itemToCraft);
-				onCraftMatrixChanged(player.inventory);
+				slot.set(null);
+				slot.onTake(itemToCraft);
+				slotsChanged(player.inventory);
 				mergeItems(itemToCraft, resultSlots);
 				if(itemToCraft.stackSize > 0) {
 					storeOrDropItem(player, itemToCraft);
@@ -609,7 +609,7 @@ public abstract class Container
 			Slot slot = getSlotFromList(slots, i);
 			if(slot == null) continue;
 
-			ItemStack stackInSlot = slot.getStack();
+			ItemStack stackInSlot = slot.getItem();
 			if(stackInSlot == null) {
 				return max;
 			}
@@ -630,25 +630,25 @@ public abstract class Container
 	 * Slots to move items from when using MOVE_ALL or MOVE_SIMILAR.
 	 * If the return value is null, MOVE_ALL and MOVE_SIMILAR won't do anything!
 	 */
-	public abstract List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, EntityPlayer player);
+	public abstract List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player);
 
 	/**
 	 * Slots to move items to when using any MOVE action.
 	 * If the return value is null, all MOVE actions won't do anything!
 	 */
-	public abstract List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, EntityPlayer player);
+	public abstract List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player);
 
 	/**
 	 * Pick up all items similar to the one the player is holding.
 	 * Full stacks are not picked up.
 	 */
-	public void pickupSimilarItems(EntityPlayer player) {
+	public void pickupSimilarItems(Player player) {
 		ItemStack item = player.inventory.getHeldItemStack();
 		if(item == null) {
 			return;
 		}
 
-		List<Slot> slots = inventorySlots;
+		List<Slot> slots = this.slots;
 		for(int i=0; i < slots.size(); i++) {
 			Slot slot1 = slots.get(i);
 
@@ -656,7 +656,7 @@ public abstract class Container
 				continue;
 			}
 
-			ItemStack slotStack = slot1.getStack();
+			ItemStack slotStack = slot1.getItem();
 			if(slotStack == null) {
 				continue;
 			}
@@ -672,7 +672,7 @@ public abstract class Container
 					item.stackSize += amount;
 
 					if(slotStack.stackSize <= 0) {
-						slot1.putStack(null);
+						slot1.set(null);
 					}
 				}
 			}
@@ -684,19 +684,19 @@ public abstract class Container
 	/**
 	 * Spread the Item the player is holding across all provided slots.
 	 */
-	public void dragItemsAcrossSlots(EntityPlayer player, InventoryAction action, int[] slots) {
+	public void dragItemsAcrossSlots(Player player, InventoryAction action, int[] slots) {
 		ItemStack draggingItemStack = player.inventory.getHeldItemStack();
 		
 		if(action == InventoryAction.CREATIVE_DRAG) {
 			for(int i=0; i < slots.length; i++) {
 				Slot slot = getSlot(slots[i]);
-				if(slot == null || !slot.enableDragAndPickup() || !slot.canPutStackInSlot(draggingItemStack) || slot.getStack() != null) {
+				if(slot == null || !slot.enableDragAndPickup() || !slot.mayPlace(draggingItemStack) || slot.getItem() != null) {
 					continue;
 				}
 				ItemStack stack = draggingItemStack.copy();
 				stack.stackSize = stack.getMaxStackSize();
-				slot.putStack(stack);
-				slot.onSlotChanged();
+				slot.set(stack);
+				slot.setChanged();
 			}
 			player.inventory.setHeldItemStack(null);
 			return;
@@ -718,13 +718,13 @@ public abstract class Container
 
 		for(int i=0; i < slots.length; i++) {
 			Slot slot = getSlot(slots[i]);
-			if(slot == null || !slot.enableDragAndPickup() || !slot.canPutStackInSlot(draggingItemStack)) {
+			if(slot == null || !slot.enableDragAndPickup() || !slot.mayPlace(draggingItemStack)) {
 				continue;
 			}
-			ItemStack stackInSlot = slot.getStack();
+			ItemStack stackInSlot = slot.getItem();
 
 			int amount = itemsPerSlot;
-			amount = Math.min(amount, slot.getSlotStackLimit());
+			amount = Math.min(amount, slot.getMaxStackSize());
 			if(stackInSlot != null) {
 				amount = Math.min(amount, stackInSlot.getMaxStackSize() - stackInSlot.stackSize);
 			}
@@ -734,7 +734,7 @@ public abstract class Container
 			}
 
 			if(stackInSlot == null) {
-				slot.putStack(draggingItemStack.splitStack(amount));
+				slot.set(draggingItemStack.splitStack(amount));
 			}else if(stackInSlot.canStackWith(draggingItemStack)) {
 				draggingItemStack.stackSize -= amount;
 
@@ -750,8 +750,8 @@ public abstract class Container
 		}
 	}
 
-	public void onCraftGuiClosed(EntityPlayer player) {
-		InventoryPlayer inventory = player.inventory;
+	public void onCraftGuiClosed(Player player) {
+		Inventory inventory = player.inventory;
 		if(inventory.getHeldItemStack() != null) {
 			ItemStack stack = inventory.getHeldItemStack();
 			inventory.setHeldItemStack(null);
@@ -764,71 +764,71 @@ public abstract class Container
 	 * If the inventory does not have enough space, drop the item.
 	 * If the stack size is already less than or zero nothing happens
 	 */
-	public void storeOrDropItem(EntityPlayer player, ItemStack stack) {
+	public void storeOrDropItem(Player player, ItemStack stack) {
 		if(stack == null || stack.stackSize <= 0) {
 			return;
 		}
-		InventoryPlayer inventory = player.inventory;
+		Inventory inventory = player.inventory;
 		inventory.insertItem(stack, false);
 		if(stack.stackSize > 0) {
 			player.dropPlayerItem(stack);
 		}
 	}
 
-	public void onCraftMatrixChanged(IInventory iinventory)
+	public void slotsChanged(Container iinventory)
 	{
-		updateInventory();
+		broadcastChanges();
 	}
 
-	public boolean getCanCraft(EntityPlayer entityplayer)
+	public boolean isSynched(Player entityplayer)
 	{
-		return !field_20918_b.contains(entityplayer);
+		return !unSynchedPlayers.contains(entityplayer);
 	}
 
-	public void setCanCraft(EntityPlayer entityplayer, boolean flag)
+	public void setSynched(Player entityplayer, boolean flag)
 	{
 		if(flag)
 		{
-			field_20918_b.remove(entityplayer);
+			unSynchedPlayers.remove(entityplayer);
 		} else
 		{
-			field_20918_b.add(entityplayer);
+			unSynchedPlayers.add(entityplayer);
 		}
 	}
 
-	public void putStackInSlot(int i, ItemStack itemstack)
+	public void setItem(int i, ItemStack itemstack)
 	{
-		getSlot(i).putStack(itemstack);
+		getSlot(i).set(itemstack);
 	}
 
-	public void putStacksInSlots(ItemStack[] aitemstack)
+	public void setAll(ItemStack[] aitemstack)
 	{
 		for(int i = 0; i < aitemstack.length; i++)
 		{
-			getSlot(i).putStack(aitemstack[i]);
+			getSlot(i).set(aitemstack[i]);
 		}
 
 	}
 
-	public void updateClientProgressBar(int id, int value)
+	public void setData(int id, int value)
 	{
 	}
 
-	public short getActionId(InventoryPlayer inventoryplayer)
+	public short backup(Inventory inventoryplayer)
 	{
-		lastActionId++;
-		return lastActionId;
+		changeUid++;
+		return changeUid;
 	}
 
-	public void func_20113_a(short word0)
+	public void deleteBackup(short word0)
 	{
 	}
 
-	public void func_20110_b(short word0)
+	public void rollbackToBackup(short word0)
 	{
 	}
 
-	public abstract boolean isUsableByPlayer(EntityPlayer entityplayer);
+	public abstract boolean stillValid(Player entityplayer);
 
 	/**
 	 * Merge the given ItemStack into the given slots.
@@ -840,17 +840,17 @@ public abstract class Container
 		for(int i = 0; i < targetSlots.size(); i++) {
 			Slot slot = getSlotFromList(targetSlots, i);
 			if(slot == null) continue;
-			ItemStack stackInSlot = slot.getStack();
+			ItemStack stackInSlot = slot.getItem();
 
-			if(stackInSlot == null || !slot.canPutStackInSlot(stack) || !stack.canStackWith(stackInSlot)) continue;
+			if(stackInSlot == null || !slot.mayPlace(stack) || !stack.canStackWith(stackInSlot)) continue;
 
-			int amount = Math.min(stack.stackSize, stack.getMaxStackSize(slot.getInventory()) - stackInSlot.stackSize);
-			amount = Math.min(amount, slot.getSlotStackLimit() - stackInSlot.stackSize);
+			int amount = Math.min(stack.stackSize, stack.getMaxStackSize(slot.getContainer()) - stackInSlot.stackSize);
+			amount = Math.min(amount, slot.getMaxStackSize() - stackInSlot.stackSize);
 			if(amount <= 0) continue;
 
 			stack.stackSize -= amount;
 			stackInSlot.stackSize += amount;
-			slot.onSlotChanged();
+			slot.setChanged();
 
 			if(stack.stackSize == 0) return;
 		}
@@ -858,16 +858,16 @@ public abstract class Container
 		for(int i = 0; i < targetSlots.size(); i++) {
 			Slot slot = getSlotFromList(targetSlots, i);
 			if(slot == null) continue;
-			ItemStack stackInSlot = slot.getStack();
+			ItemStack stackInSlot = slot.getItem();
 
-			if(stackInSlot != null || !slot.canPutStackInSlot(stack)) continue;
+			if(stackInSlot != null || !slot.mayPlace(stack)) continue;
 
-			int amount = Math.min(stack.stackSize, stack.getMaxStackSize(slot.getInventory()));
-			amount = Math.min(amount, slot.getSlotStackLimit());
+			int amount = Math.min(stack.stackSize, stack.getMaxStackSize(slot.getContainer()));
+			amount = Math.min(amount, slot.getMaxStackSize());
 			if(amount <= 0) continue;
 
-			slot.putStack(stack.splitStack(amount));
-			slot.onSlotChanged();
+			slot.set(stack.splitStack(amount));
+			slot.setChanged();
 
 			if(stack.stackSize <= 0) return;
 		}
@@ -908,6 +908,6 @@ public abstract class Container
 	}
 
 	public int getHotbarSlotId(int number) {
-		return inventorySlots.size() - 10 + number;
+		return slots.size() - 10 + number;
 	}
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/player/inventory/ContainerChest.java b/src/main/java/net/minecraft/core/player/inventory/menu/ContainerMenu.java
similarity index 52%
rename from src/main/java/net/minecraft/core/player/inventory/ContainerChest.java
rename to src/main/java/net/minecraft/core/player/inventory/menu/ContainerMenu.java
index efad28dab..5ed9aa4bf 100644
--- a/src/main/java/net/minecraft/core/player/inventory/ContainerChest.java
+++ b/src/main/java/net/minecraft/core/player/inventory/menu/ContainerMenu.java
@@ -1,65 +1,66 @@
-package net.minecraft.core.player.inventory;
+package net.minecraft.core.player.inventory.menu;
 
 import java.util.List;
 
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
 
-public class ContainerChest extends Container {
+public class ContainerMenu extends AbstractContainerMenu {
 	
-	private IInventory field_20125_a;
+	private Container container;
 	private int numberOfRows;
 	
-	public ContainerChest(IInventory iinventory, IInventory iinventory1) {
-		field_20125_a = iinventory1;
-		numberOfRows = iinventory1.getSizeInventory() / 9;
+	public ContainerMenu(Container playerContainer, Container container) {
+		this.container = container;
+		numberOfRows = container.getContainerSize() / 9;
 		int i = (numberOfRows - 4) * 18;
 		for (int j = 0; j < numberOfRows; j++) {
 			for (int i1 = 0; i1 < 9; i1++) {
-				addSlot(new Slot(iinventory1, i1 + j * 9, 8 + i1 * 18, 18 + j * 18));
+				addSlot(new Slot(container, i1 + j * 9, 8 + i1 * 18, 18 + j * 18));
 			}
 
 		}
 
 		for (int k = 0; k < 3; k++) {
 			for (int j1 = 0; j1 < 9; j1++) {
-				addSlot(new Slot(iinventory, j1 + k * 9 + 9, 8 + j1 * 18, 103 + k * 18 + i));
+				addSlot(new Slot(playerContainer, j1 + k * 9 + 9, 8 + j1 * 18, 103 + k * 18 + i));
 			}
 
 		}
 
 		for (int l = 0; l < 9; l++) {
-			addSlot(new Slot(iinventory, l, 8 + l * 18, 161 + i));
+			addSlot(new Slot(playerContainer, l, 8 + l * 18, 161 + i));
 		}
 
 	}
 
 	@Override
-	public boolean isUsableByPlayer(EntityPlayer entityplayer) {
-		return field_20125_a.canInteractWith(entityplayer);
+	public boolean stillValid(Player entityplayer) {
+		return container.stillValid(entityplayer);
 	}
 	
 	@Override
-	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
+	public List<Integer> getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
 		int chestSize = numberOfRows * 9;
 		
-		if(slot.id >= 0 && slot.id < chestSize) {
+		if(slot.index >= 0 && slot.index < chestSize) {
 			// Chest inventory
 			return getSlots(0, chestSize, false); 
 		}
 		
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.id >= chestSize && slot.id < chestSize + 27) {
+			if(slot.index >= chestSize && slot.index < chestSize + 27) {
 				// Main Inventory
 				return getSlots(chestSize, 27, false);
 			}
-			if(slot.id >= chestSize + 27 && slot.id < chestSize + 36) {
+			if(slot.index >= chestSize + 27 && slot.index < chestSize + 36) {
 				// Hotbar
 				return getSlots(chestSize + 27, 9, false);
 			}
 		}else {
-			if(slot.id >= chestSize && slot.id < chestSize + 36) {
+			if(slot.index >= chestSize && slot.index < chestSize + 36) {
 				// Full Inventory
 				return getSlots(chestSize, 36, false);
 			}
@@ -69,10 +70,10 @@ public class ContainerChest extends Container {
 	}
 
 	@Override
-	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, EntityPlayer player) {
+	public List<Integer> getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
 		int chestSize = numberOfRows * 9;
 		
-		if(slot.id < chestSize) {
+		if(slot.index < chestSize) {
 			// Clicked chest
 			return getSlots(chestSize, 36, true); // Inventory
 		}else {
